/*
     Here is a simple program that we can analyze. It has a global
     variable, a local variable, it calls a local function, a
     C Runtime library function, and a couple of Win32 library functions.

     Try to follow this program every step of the way from being a
     source code file to being a running process. Compare this
     program's assembly language listing with what is inside its
     obj file, with what is inside its exe file, and with what the
     process looks like in virtual memory when it is loaded and running.
     In particular, notice how at each step of the way, more symbols
     are resolved. Pay attention to what each symbol gets resolved to.
*/
#include <stdio.h>
#include <windows.h>

int sleepTime = 5000;

int incrementSleepTime(int time)
{
   return sleepTime + time;
}

int main()
{
   int x = 0;
   int y;

   while( 1 )
   {
      // call a Win32 library function
      x = GetTickCount();
      // call a C Runtime library function
      printf("the value of TickCount = %d\n", x);
      // call a local function
      y = incrementSleepTime(500);
      // call another Win32 library function
      Sleep(y);  // sleep for 5 seconds
   }

   return 0;
}