/*
    This program calls an externally defined function. Suppose that
    we try to use the definition of test_function() defined in the
    file calling-conventions2b.c. What is it about the way these files
    are complied that prevents the linker from linking the external
    reference in this file to the definition of test_function() given
    in the other file? In other words, what specific mechanism does the
    the compiler use to avoid accidentally linking files like these?
    (To figure out the annswer, you have to look at the assembly
    language listings of these two files.)

    What would be the result if the linker went ahead and linked the
    definition of test_function() defined in calling-conventions2b.c
    to the external reference in this file?

    There are two ways to fix this problem, one way by modifying this
    file and the other way by modifying calling-conventions2b.c. Try
    both ways and be sure to examine the assembly language listings.
*/
#include <stdio.h>

// prototype
extern int test_function(int, int);

int main()
{
   int x = 2;
   int y = 3;
   int z;
   z = test_function(x, y);
   printf("x + y = %d", z);
   return 0;
}
